Index: issm/trunk/examples/IceflowModels/SquareShelf.par
===================================================================
--- issm/trunk/examples/IceflowModels/SquareShelf.par	(revision 18301)
+++ issm/trunk/examples/IceflowModels/SquareShelf.par	(revision 18301)
@@ -0,0 +1,55 @@
+%Start defining model parameters here
+
+%Geometry
+hmin=300;
+hmax=1000;
+ymin=min(md.mesh.y);
+ymax=max(md.mesh.y);
+xmin=min(md.mesh.x);
+xmax=max(md.mesh.x);
+md.geometry.thickness=hmax+(hmin-hmax)*(md.mesh.y-ymin)/(ymax-ymin)+0.1*(hmin-hmax)*(md.mesh.x-xmin)/(xmax-xmin);
+md.geometry.base=-md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness;
+md.geometry.surface=md.geometry.base+md.geometry.thickness;
+
+%Initial velocity and pressure
+x     = transpose(ncread('../Data/SquareShelf.nc','x'));
+y     = transpose(ncread('../Data/SquareShelf.nc','y'));
+vx    = transpose(ncread('../Data/SquareShelf.nc','vx'));
+vy    = transpose(ncread('../Data/SquareShelf.nc','vy'));
+index = transpose(ncread('../Data/SquareShelf.nc','index'));
+md.initialization.vx=InterpFromMeshToMesh2d(index,x,y,vx,md.mesh.x,md.mesh.y);
+md.initialization.vy=InterpFromMeshToMesh2d(index,x,y,vy,md.mesh.x,md.mesh.y);
+clear vx vy x y index;
+md.initialization.vz=zeros(md.mesh.numberofvertices,1);
+md.initialization.pressure=zeros(md.mesh.numberofvertices,1);
+
+%Materials
+md.initialization.temperature=(273-20)*ones(md.mesh.numberofvertices,1);
+md.materials.rheology_B=paterson(md.initialization.temperature);
+md.materials.rheology_n=3*ones(md.mesh.numberofelements,1);
+
+%Friction
+md.friction.coefficient=20*ones(md.mesh.numberofvertices,1);
+md.friction.coefficient(find(md.mask.groundedice_levelset<0.))=0.;
+md.friction.p=ones(md.mesh.numberofelements,1);
+md.friction.q=ones(md.mesh.numberofelements,1);
+
+%Numerical parameters
+md.stressbalance.viscosity_overshoot=0.3;
+md.masstransport.stabilization=1;
+md.thermal.stabilization=1;
+md.settings.waitonlock=30;
+md.verbose=verbose(0);
+md.stressbalance.restol=0.10;
+md.steadystate.reltol=0.02;
+md.stressbalance.reltol=0.02;
+md.stressbalance.abstol=NaN;
+md.timestepping.time_step=1;
+md.timestepping.final_time=3;
+
+%Boundary conditions:
+md=SetIceShelfBC(md,'./SquareFront.exp');
+
+%Change name so that no test have the same name
+A=dbstack;
+if (length(A)>2), md.miscellaneous.name=A(3).file(1:end-2); end
Index: issm/trunk/examples/IceflowModels/eismint.m
===================================================================
--- issm/trunk/examples/IceflowModels/eismint.m	(revision 18301)
+++ issm/trunk/examples/IceflowModels/eismint.m	(revision 18301)
@@ -0,0 +1,51 @@
+md=model();
+
+%Create mesh with roundmesh
+md=roundmesh(md,750000,30000);
+
+%Set mask
+md=setmask(md,'','');
+
+%Parameterize model
+md=parameterize(md,'EISMINT.par');
+
+%We extrude the model to have a 3d model
+md=extrude(md,10,1);
+
+%Set ice flow approximation
+md=setflowequation(md,'SIA','all');
+
+%Create boundary conditions: zero velocity on the bed
+pos=find(md.mesh.vertexonbase);
+md.stressbalance.spcvx(pos)=0;
+md.stressbalance.spcvy(pos)=0;
+md.stressbalance.spcvz(pos)=0;
+
+%Go Solve
+md.cluster=generic('np',2);
+md.verbose.convergence=1;
+md=solve(md,StressbalanceSolutionEnum());
+vel=DepthAverage(md,sqrt(md.results.StressbalanceSolution.Vx.^2+md.results.StressbalanceSolution.Vy.^2));
+
+%Calculate analytical velocity
+constant=0.3;
+vx_obs=constant/2*md.mesh.x.*(md.geometry.thickness).^-1;
+vy_obs=constant/2*md.mesh.y.*(md.geometry.thickness).^-1;
+vel_obs=sqrt(vx_obs.^2+vy_obs.^2);
+vel_obs=project2d(md,vel_obs,1);
+
+plotmodel(md,...
+	'data',vel    ,'view',2,'caxis',[0 200],'title','Modelled velocity',...
+	'data',vel_obs,'view',2,'caxis',[0 200],'title','Analytical velocity',...
+	'data',abs(vel-vel_obs)./(vel_obs+eps)*100,'caxis',[0 30],'view',2,'title','Relative misfit (%)');
+
+subplot(2,2,4)
+hold on;
+plot(sqrt((md.mesh.x2d).^2+(md.mesh.y2d).^2),vel,'r.');
+plot(sqrt((md.mesh.x2d).^2+(md.mesh.y2d).^2),vel_obs,'b.');
+title('Analytical vs calculated velocity');
+xlabel('distance to the center of the icesheet [m]');
+ylabel('velocity (m/yr)');
+legend('calculated velocity','exact velocity');
+axis([0 750000 0 200]);
+hold off;
Index: issm/trunk/examples/IceflowModels/runme.m
===================================================================
--- issm/trunk/examples/IceflowModels/runme.m	(revision 18301)
+++ issm/trunk/examples/IceflowModels/runme.m	(revision 18301)
@@ -0,0 +1,8 @@
+md=triangle(model(),'Square.exp',80000.);
+md=setmask(md,'all','');
+md=parameterize(md,'SquareShelf.par');
+md=extrude(md,3,1);
+%Set flow equation
+md=setflowequation(md,'HO','Contour.exp','fill','SSA','coupling','tiling');
+%Solve
+md=solve(md,StressbalanceSolutionEnum);
Index: issm/trunk/examples/Inversion/CheatSheet.m
===================================================================
--- issm/trunk/examples/Inversion/CheatSheet.m	(revision 18301)
+++ issm/trunk/examples/Inversion/CheatSheet.m	(revision 18301)
@@ -0,0 +1,77 @@
+step=1;
+if step==1
+	%Generate observation
+	md = model;
+	md = triangle(md,'DomainOutline.exp',100000);
+
+	%Hands on: STEP 2
+	md = setmask(md,'','');
+
+	md = parameterize(md,'Square.par');
+	md = setflowequation(md,'SSA','all');
+	md.cluster = generic('np',2);
+
+	%Hands on: STEP 1
+	md.geometry.base    = md.geometry.base+100;
+	md.geometry.surface = md.geometry.surface+100;
+
+	%Hands on: STEP 3
+	md.materials.rheology_B(:) = 1.8*10^8;
+
+	%Hands on: STEP 4
+	md.friction.coefficient(:)=50;
+	md.friction.coefficient(find(md.mesh.x<600000 & md.mesh.x>400000))=10;
+
+	md = solve(md,StressbalanceSolutionEnum);
+
+	plotmodel(md,'data',md.friction.coefficient,'figure',1);
+	plotmodel(md,'data',md.results.StressbalanceSolution.Vel,'figure',2);
+
+	save model1 md
+end
+if step==2
+	loadmodel('model1.mat');
+
+	%Hands on: STEP 1
+	md.friction.coefficient(:)=50;
+
+	%results of previous run are taken as observations
+	md.inversion=m1qn3inversion();
+	md.inversion.vx_obs  = md.results.StressbalanceSolution.Vx;
+	md.inversion.vy_obs  = md.results.StressbalanceSolution.Vy;
+	md.inversion.vel_obs = md.results.StressbalanceSolution.Vel;
+
+	md = solve(md,StressbalanceSolutionEnum);
+
+	plotmodel(md,'data',md.friction.coefficient,'figure',1);
+	plotmodel(md,'data',md.results.StressbalanceSolution.Vel,'figure',2);
+
+	save model2 md
+end
+if step==3
+	%invert for ice rigidity
+	loadmodel('model2.mat');
+
+	%Set up inversion parameters
+	maxsteps = 20;
+	md.inversion.iscontrol = 1;
+
+	%Hands on: STEP 1
+	md.inversion.control_parameters = {'FrictionCoefficient'};
+	md.inversion.maxsteps = maxsteps;
+
+	%Hands on: STEP 2
+	md.inversion.cost_functions = 101;
+	md.inversion.cost_functions_coefficients = ones(md.mesh.numberofvertices,1);
+
+	%Hands on: STEP 3
+	md.inversion.min_parameters = 1*ones(md.mesh.numberofvertices,1);
+	md.inversion.max_parameters = 100*ones(md.mesh.numberofvertices,1);
+
+	%Go solve!
+	md.verbose=verbose(0);
+	md=solve(md,StressbalanceSolutionEnum);
+
+	plotmodel(md,'data',md.results.StressbalanceSolution.FrictionCoefficient,'figure',1,'caxis',[10 50]);
+	plotmodel(md,'data',md.results.StressbalanceSolution.Vel,'figure',2);  
+end
Index: issm/trunk/examples/Inversion/DomainOutline.exp
===================================================================
--- issm/trunk/examples/Inversion/DomainOutline.exp	(revision 18301)
+++ issm/trunk/examples/Inversion/DomainOutline.exp	(revision 18301)
@@ -0,0 +1,10 @@
+## Name:DomainOutline
+## Icon:0
+# Points Count  Value
+5 1.000000
+# X pos Y pos
+0 0
+1000000 0
+1000000 1000000
+0 1000000
+0 0
Index: issm/trunk/examples/Inversion/Front.exp
===================================================================
--- issm/trunk/examples/Inversion/Front.exp	(revision 18301)
+++ issm/trunk/examples/Inversion/Front.exp	(revision 18301)
@@ -0,0 +1,10 @@
+## Name:icefront
+## Icon:0
+# Points Count  Value
+5 1.
+# X pos Y pos
+-1000 900000
+-1000 1100000
+1100000 1100000
+1100000 900000
+-1000 900000
Index: issm/trunk/examples/Inversion/Square.par
===================================================================
--- issm/trunk/examples/Inversion/Square.par	(revision 18301)
+++ issm/trunk/examples/Inversion/Square.par	(revision 18301)
@@ -0,0 +1,24 @@
+%Start defining model parameters here
+
+disp('      creating thickness');
+hmin = 300;
+hmax = 1000;
+ymin = min(md.mesh.y);
+ymax = max(md.mesh.y);
+md.geometry.thickness = hmax+(hmin-hmax)*(md.mesh.y-ymin)/(ymax-ymin);
+md.geometry.base      = -md.materials.rho_ice/md.materials.rho_water*md.geometry.thickness;
+md.geometry.surface   = md.geometry.base+md.geometry.thickness;
+
+disp('      creating drag');
+md.friction.coefficient=200*ones(md.mesh.numberofvertices,1);
+md.friction.coefficient(find(md.mask.groundedice_levelset<0.))=0.;
+md.friction.p = ones(md.mesh.numberofelements,1);
+md.friction.q = ones(md.mesh.numberofelements,1);
+
+disp('      creating flow law paramter');
+md.materials.rheology_B=1.8*10^8*ones(md.mesh.numberofvertices,1);
+md.materials.rheology_B(find(md.mesh.x<md.mesh.y))=1.4*10^8;
+md.materials.rheology_n=3*ones(md.mesh.numberofelements,1);
+
+disp('      creating boundary conditions');
+md=SetIceShelfBC(md,'Front.exp');
Index: issm/trunk/examples/Inversion/runme.m
===================================================================
--- issm/trunk/examples/Inversion/runme.m	(revision 18301)
+++ issm/trunk/examples/Inversion/runme.m	(revision 18301)
@@ -0,0 +1,78 @@
+step=1;
+if step==1
+	%Generate observation
+	md = model;
+	md = triangle(md,'DomainOutline.exp',100000);
+	md = setmask(md,'all','');
+	md = parameterize(md,'Square.par');
+	md = setflowequation(md,'SSA','all');
+	md.cluster = generic('np',2);
+
+	md = solve(md,StressbalanceSolutionEnum);
+
+	plotmodel(md,'data',md.materials.rheology_B,'caxis',[ 1.3 1.9]*10^8,'figure',1,'gridded#all',1);
+	plotmodel(md,'data',md.results.StressbalanceSolution.Vel,'figure',2,'gridded#all',1);  
+
+	save model1 md
+end
+if step==2
+	%Modify rheology, now constant
+	loadmodel('model1.mat');
+	md.materials.rheology_B(:) = 1.8*10^8;
+
+	%results of previous run are taken as observations
+	md.inversion=m1qn3inversion();
+	md.inversion.vx_obs  = md.results.StressbalanceSolution.Vx;
+	md.inversion.vy_obs  = md.results.StressbalanceSolution.Vy;
+	md.inversion.vel_obs = md.results.StressbalanceSolution.Vel;
+
+	md = solve(md,StressbalanceSolutionEnum);
+
+	plotmodel(md,'data',md.materials.rheology_B,'caxis',[ 1.3 1.9]*10^8,'figure',1);
+	plotmodel(md,'data',md.results.StressbalanceSolution.Vel,'figure',2);  
+
+	save model2 md
+end
+if step==3
+	%invert for ice rigidity
+	loadmodel('model2.mat');
+
+	%Set up inversion parameters
+	maxsteps = 20;
+	md.inversion.iscontrol = 1;
+	md.inversion.control_parameters = {'MaterialsRheologyBbar'};
+	md.inversion.maxsteps = maxsteps;
+	md.inversion.cost_functions = 101;
+	md.inversion.cost_functions_coefficients = ones(md.mesh.numberofvertices,1);
+	md.inversion.min_parameters    = paterson(273)*ones(md.mesh.numberofvertices,1);
+	md.inversion.max_parameters    = paterson(200)*ones(md.mesh.numberofvertices,1);
+
+	%Go solve!
+	md.verbose=verbose(0);
+	md=solve(md,StressbalanceSolutionEnum);
+
+	plotmodel(md,'data',md.results.StressbalanceSolution.MaterialsRheologyBbar,'caxis',[ 1.3 1.9]*10^8,'figure',1);
+	plotmodel(md,'data',md.results.StressbalanceSolution.Vel,'figure',2);  
+end
+if step==4
+	%invert for ice rigidity
+	loadmodel('model2.mat');
+
+	%Set up inversion parameters
+	maxsteps = 20;
+	md.inversion.iscontrol = 1;
+	md.inversion.control_parameters = {'MaterialsRheologyBbar'};
+	md.inversion.maxsteps = maxsteps;
+	md.inversion.cost_functions = [101 502];
+	md.inversion.cost_functions_coefficients      = ones(md.mesh.numberofvertices,1);
+	md.inversion.cost_functions_coefficients(:,2) = 10^-16*ones(md.mesh.numberofvertices,1);
+	md.inversion.min_parameters    = paterson(273)*ones(md.mesh.numberofvertices,1);
+	md.inversion.max_parameters    = paterson(200)*ones(md.mesh.numberofvertices,1);
+
+	%Go solve!
+	md.verbose=verbose(0);
+	md=solve(md,StressbalanceSolutionEnum);
+
+	plotmodel(md,'data',md.results.StressbalanceSolution.MaterialsRheologyBbar,'caxis',[ 1.3 1.9]*10^8,'figure',1);
+	plotmodel(md,'data',md.results.StressbalanceSolution.Vel,'figure',2);  
+end
Index: issm/trunk/examples/Jakobshavn/Jks.par
===================================================================
--- issm/trunk/examples/Jakobshavn/Jks.par	(revision 18081)
+++ issm/trunk/examples/Jakobshavn/Jks.par	(revision 18301)
@@ -6,5 +6,5 @@
 %Load SeaRISE dataset
 disp('   Loading SeaRISE data from NetCDF');
-ncdata = './Greenland_5km_v1.1.nc';
+ncdata = '../Data/Greenland_5km_dev1.2.nc';
 x1    = ncread(ncdata,'x1');
 y1    = ncread(ncdata,'y1');
@@ -58,3 +58,4 @@
 disp('   Set other boundary conditions');
 md=SetMarineIceSheetBC(md,'./Front.exp');
-md.basalforcings.melting_rate=zeros(md.mesh.numberofvertices,1);
+md.basalforcings.floatingice_melting_rate=zeros(md.mesh.numberofvertices,1);
+md.basalforcings.groundedice_melting_rate=zeros(md.mesh.numberofvertices,1);
Index: issm/trunk/examples/Jakobshavn/runme.m
===================================================================
--- issm/trunk/examples/Jakobshavn/runme.m	(revision 18081)
+++ issm/trunk/examples/Jakobshavn/runme.m	(revision 18301)
@@ -1,3 +1,3 @@
-steps=[1:3];
+steps=[4];
 
 if any(steps==1)
@@ -6,7 +6,7 @@
 
 	%Get observed velocity field on mesh nodes
-	ncdata='Greenland_5km_v1.1.nc';
+	ncdata='../Data/Greenland_5km_dev1.2.nc';
 	if ~exist(ncdata,'file'), 
-		error('Download Greenland5km_v1.1.nc first on http://websrv.cs.umt.edu/isis/index.php/Present_Day_Greenland');
+		error('File Greenland_5km_dev1.2.nc not downloaded in Data Directory.  Please cd ../Data and run the download script.');
 	end
 	x1   = ncread(ncdata,'x1');
@@ -84,5 +84,5 @@
 		'colorbar#1','off','colorbar#2','on','colorbartitle#2','[m/yr]',...
 		'caxis#1-2',[0,7000],...
-		'data',md.geometry.bed,'title','Bed elevation',...
+		'data',md.geometry.base,'title','Base elevation',...
 		'data',md.results.StressbalanceSolution.FrictionCoefficient,...
 		'title','Friction Coefficient',...
Index: issm/trunk/examples/Pig/CheatSheet.m
===================================================================
--- issm/trunk/examples/Pig/CheatSheet.m	(revision 18301)
+++ issm/trunk/examples/Pig/CheatSheet.m	(revision 18301)
@@ -0,0 +1,18 @@
+if any(steps==6)
+	% Load Model
+	md = loadmodel('./Models/PIG.Control_drag');
+	md.inversion.iscontrol=0;
+
+	disp('   Extruding mesh')
+	number_of_layers=3;
+	md=extrude(md,number_of_layers,0.9);
+
+	disp('   Using HO Ice Flow Model')
+	md=setflowequation(md, 'HO', 'all');
+
+	% Solve
+	md=solve(md,StressbalanceSolutionEnum);
+
+	% Save Model
+	save ./Models/PIG.ModelHO md;
+end
Index: issm/trunk/examples/Pig/DomainOutline.bkp
===================================================================
--- issm/trunk/examples/Pig/DomainOutline.bkp	(revision 18301)
+++ issm/trunk/examples/Pig/DomainOutline.bkp	(revision 18301)
@@ -0,0 +1,120 @@
+## Name:
+## Icon:0
+# Points Count Value
+114 25000.000000
+# X pos Y pos
+-1712113.0179281300 -349656.0205056490
+-1711509.1917759699 -349354.1074295690
+-1709240.6586108401 -349354.1074295690
+-1707080.1508345299 -348922.0058743060
+-1705459.7700022999 -347193.5996532570
+-1703083.2114483600 -345249.1426545770
+-1701138.7544496800 -344168.8887664210
+-1698438.1197292900 -343952.8379887900
+-1698006.0181740201 -341900.3556012940
+-1693793.0280102200 -340279.9747690600
+-1691092.3932898301 -339631.8224361670
+-1688391.7585694401 -339415.7716585360
+-1686447.3015707601 -340063.9239914290
+-1683530.6160727399 -341036.1524907690
+-1682558.3875734000 -343304.6856558960
+-1682134.7209454600 -344182.1487658350
+-1682126.2860181299 -345681.2442098390
+-1681072.0444963200 -345932.4393879640
+-1680634.4718407800 -346682.5639403050
+-1680571.9614614199 -348557.8753211580
+-1677446.4424933300 -348370.3441830730
+-1675508.6207331200 -349495.5310115840
+-1676616.9911885399 -353567.0975933760
+-1672991.8601872099 -353799.6175753630
+-1668839.1631938200 -353999.1991486380
+-1667132.2298986400 -355121.4651541420
+-1666069.5534494901 -357496.8595698890
+-1662944.0344814099 -358309.4945015920
+-1660756.1712037399 -358747.0671571240
+-1657922.9836098100 -361682.8074238540
+-1656579.2228470000 -364003.8487410000
+-1653004.8841628900 -364748.0635758530
+-1653442.4568184200 -361622.5446077650
+-1651129.5727820301 -355684.0585683980
+-1648929.2928810001 -350845.9692010000
+-1646260.7698359799 -347802.2804785470
+-1644571.8968503401 -341785.6704672340
+-1643503.3064999001 -340869.0986596620
+-1643190.7546030900 -336680.9032424240
+-1642690.6715682000 -335243.1645171040
+-1641913.0916588283 -332341.0814454452
+-1640683.9739821283 -330436.6112348017
+-1637816.0327364956 -328532.1410241582
+-1635241.2508976001 -328652.8685499910
+-1631765.4107996500 -327017.1790921330
+-1625934.5618617306 -322342.6128395668
+-1620608.3852626982 -320438.1426289233
+-1616101.6204481323 -320438.1426289233
+-1611594.8556335662 -320914.2601815842
+-1607907.5026034669 -321866.4952869060
+-1602991.0318966676 -324723.2006028712
+-1599713.3847588014 -327579.9059188365
+-1593977.5022675355 -328532.1410241582
+-1590699.8551296694 -334721.6692087495
+-1589259.8391499999 -338300.0840570000
+-1588627.0898328500 -343572.9950327750
+-1588056.6000060199 -345432.3563530700
+-1586993.9235568701 -347432.6884926460
+-1589259.8391499999 -349315.9832070000
+-1585493.6744521901 -352996.1122558430
+-1585118.6121760199 -354496.3613605250
+-1585861.9157163899 -356240.3342513760
+-1586368.8197632500 -358747.0671571240
+-1587889.0972700799 -360996.6006787950
+-1586681.3716600600 -363935.4286441500
+-1585806.2263489999 -365748.2296456410
+-1586743.8820394201 -368373.6655788350
+-1586056.2678664399 -370123.9562009640
+-1585493.6744521901 -371124.1222707520
+-1586243.7990045301 -373562.0270658610
+-1428620.2472997301 -364425.2597226670
+-1414257.6683934701 -327460.5482541260
+-1412220.4351378100 -325972.8942023180
+-1404515.9240538401 -296165.1737279960
+-1387984.9332285200 -267002.0106682320
+-1375329.9306695000 -287124.5773036880
+-1374139.7661228001 -286331.1342725540
+-1347030.4625590600 -322432.7921891520
+-1351262.1587251101 -326267.7668396330
+-1381809.7154237600 -297174.8556980530
+-1381677.4749185799 -295852.4506461620
+-1382481.1222932001 -294804.4361498400
+-1398663.5713381099 -316073.2308695170
+-1409694.4697897099 -363328.2128408530
+-1202495.3746585899 -351317.7619567180
+-1191463.4809399999 -350233.9748030000
+-1232161.1083569999 -292094.5070650000
+-1231243.1167609999 -288422.5406810000
+-1360067.9373810000 -107884.1934940000
+-1423274.3497420000 -81217.9259650000
+-1402446.7987670000 -45916.9921070000
+-1478343.8065599999 60338.8188030000
+-1513291.7310790000 4210.3339700000
+-1523175.9925589999 11976.5394190000
+-1503760.4789370000 36334.1837800000
+-1528509.5619775900 63667.6809196406
+-1623055.4918765700 62841.1506965373
+-1648011.3012850001 32874.5178730000
+-1638219.3909290000 20634.6299280000
+-1650153.2816760000 31038.5346810000
+-1725734.5897359999 -61372.6193030000
+-1719614.6457630000 -69022.5492690000
+-1759088.2843859999 -114004.1374660000
+-1755416.3180020000 -117064.1094530000
+-1761230.2647760001 -126856.0198080000
+-1758170.2927900001 -130527.9861920000
+-1762148.2563720001 -135423.9413700000
+-1764902.2311590000 -131445.9777880000
+-1769798.1863370000 -134199.9525750000
+-1775000.1387139999 -131445.9777880000
+-1794277.9622269999 -153477.7760890000
+-1712576.7101950001 -225081.1205660000
+-1729939.5891459100 -335652.4567604720
+-1712113.0179281300 -349656.0205056490
+
Index: issm/trunk/examples/Pig/DomainOutline.exp
===================================================================
--- issm/trunk/examples/Pig/DomainOutline.exp	(revision 18301)
+++ issm/trunk/examples/Pig/DomainOutline.exp	(revision 18301)
@@ -0,0 +1,101 @@
+## Name:
+## Icon:0
+# Points Count Value
+95 25000.000000
+# X pos Y pos
+-1712113.0179281300 -349656.0205056490
+-1711509.1917759699 -349354.1074295690
+-1709240.6586108401 -349354.1074295690
+-1707080.1508345299 -348922.0058743060
+-1705459.7700022999 -347193.5996532570
+-1703083.2114483600 -345249.1426545770
+-1701138.7544496800 -344168.8887664210
+-1698438.1197292900 -343952.8379887900
+-1698006.0181740201 -341900.3556012940
+-1693793.0280102200 -340279.9747690600
+-1691092.3932898301 -339631.8224361670
+-1688391.7585694401 -339415.7716585360
+-1686447.3015707601 -340063.9239914290
+-1683530.6160727399 -341036.1524907690
+-1682558.3875734000 -343304.6856558960
+-1682134.7209454600 -344182.1487658350
+-1682126.2860181299 -345681.2442098390
+-1681072.0444963200 -345932.4393879640
+-1680634.4718407800 -346682.5639403050
+-1680571.9614614199 -348557.8753211580
+-1677446.4424933300 -348370.3441830730
+-1675508.6207331200 -349495.5310115840
+-1676616.9911885399 -353567.0975933760
+-1672991.8601872099 -353799.6175753630
+-1668839.1631938200 -353999.1991486380
+-1667132.2298986400 -355121.4651541420
+-1666069.5534494901 -357496.8595698890
+-1662944.0344814099 -358309.4945015920
+-1660756.1712037399 -358747.0671571240
+-1657922.9836098100 -361682.8074238540
+-1656579.2228470000 -364003.8487410000
+-1653004.8841628900 -364748.0635758530
+-1653442.4568184200 -361622.5446077650
+-1651129.5727820301 -355684.0585683980
+-1648929.2928810001 -350845.9692010000
+-1646260.7698359799 -347802.2804785470
+-1644571.8968503401 -341785.6704672340
+-1643503.3064999001 -340869.0986596620
+-1643190.7546030900 -336680.9032424240
+-1642690.6715682000 -335243.1645171040
+-1641913.0916588283 -332341.0814454452
+-1640683.9739821283 -330436.6112348017
+-1637816.0327364956 -328532.1410241582
+-1635241.2508976001 -328652.8685499910
+-1631765.4107996500 -327017.1790921330
+-1625934.5618617306 -322342.6128395668
+-1620608.3852626982 -320438.1426289233
+-1616101.6204481323 -320438.1426289233
+-1611594.8556335662 -320914.2601815842
+-1607907.5026034669 -321866.4952869060
+-1602991.0318966676 -324723.2006028712
+-1599713.3847588014 -327579.9059188365
+-1593977.5022675355 -328532.1410241582
+-1590699.8551296694 -334721.6692087495
+-1589259.8391499999 -338300.0840570000
+-1588627.0898328500 -343572.9950327750
+-1588056.6000060199 -345432.3563530700
+-1586993.9235568701 -347432.6884926460
+-1589259.8391499999 -349315.9832070000
+-1585493.6744521901 -352996.1122558430
+-1585118.6121760199 -354496.3613605250
+-1585861.9157163899 -356240.3342513760
+-1586368.8197632500 -358747.0671571240
+-1587889.0972700799 -360996.6006787950
+-1586681.3716600600 -363935.4286441500
+-1585806.2263489999 -365748.2296456410
+-1586743.8820394201 -368373.6655788350
+-1586056.2678664399 -370123.9562009640
+-1585493.6744521901 -371124.1222707520
+-1586243.7990045301 -373562.0270658610
+-1414257.6683934701 -327460.5482541260
+-1412220.4351378100 -325972.8942023180
+-1404515.9240538401 -296165.1737279960
+-1387984.9332285200 -267002.0106682320
+-1360067.9373810000 -107884.1934940000
+-1423274.3497420000 -81217.9259650000
+-1402446.7987670000 -45916.9921070000
+-1478343.8065599999 60338.8188030000
+-1503760.4789370000 36334.1837800000
+-1528509.5619775900 63667.6809196406
+-1623055.4918765700 62841.1506965373
+-1725734.5897359999 -61372.6193030000
+-1719614.6457630000 -69022.5492690000
+-1759088.2843859999 -114004.1374660000
+-1755416.3180020000 -117064.1094530000
+-1761230.2647760001 -126856.0198080000
+-1758170.2927900001 -130527.9861920000
+-1762148.2563720001 -135423.9413700000
+-1764902.2311590000 -131445.9777880000
+-1769798.1863370000 -134199.9525750000
+-1775000.1387139999 -131445.9777880000
+-1794277.9622269999 -153477.7760890000
+-1712576.7101950001 -225081.1205660000
+-1729939.5891459100 -335652.4567604720
+-1712113.0179281300 -349656.0205056490
+
Index: issm/trunk/examples/Pig/Pig.par
===================================================================
--- issm/trunk/examples/Pig/Pig.par	(revision 18301)
+++ issm/trunk/examples/Pig/Pig.par	(revision 18301)
@@ -0,0 +1,135 @@
+% Parameters to change/Try
+friction_coefficient = 10; % default [10]
+Temp_change          =  0;  % default [0 K]
+
+%Name and hemisphere
+md.miscellaneous.name='PIG';
+md.mesh.hemisphere='s';
+
+% {{{ NetCdf Loading
+disp('   Loading SeaRISE data from NetCDF');
+ncdata='../Data/Antarctica_5km_withshelves_v0.75.nc';
+x1    = ncread(ncdata,'x1');
+y1    = ncread(ncdata,'y1');
+usrf  = ncread(ncdata,'usrf')';
+topg  = ncread(ncdata,'topg')';
+temp  = ncread(ncdata,'presartm')';
+smb   = ncread(ncdata,'presprcp')';
+gflux = ncread(ncdata,'bheatflx_fox')';
+
+disp('   Loading velocities data from NetCDF');
+nsidc_vel='../Data/Antarctica_ice_velocity.nc';
+
+xmin = ncreadatt(nsidc_vel,'/','xmin');
+xmin = strtrim(xmin);  %this is a string, and we need to recover the double value
+xmin = xmin(1:end-2);  %get rid of the unit
+xmin = str2num(xmin);  %convert to double
+
+ymax = ncreadatt(nsidc_vel,'/','ymax'); 
+ymax = strtrim(ymax);  
+ymax = ymax(1:end-2);  
+ymax = str2num(ymax); 
+
+nx = ncreadatt(nsidc_vel,'/','nx');
+ny = ncreadatt(nsidc_vel,'/','ny');
+
+spacing = ncreadatt(nsidc_vel,'/','spacing'); 
+spacing = strtrim(spacing);  
+spacing = spacing(1:end-2);  
+spacing = str2num(spacing); 
+
+velx = double(ncread(nsidc_vel,'vx'));
+vely = double(ncread(nsidc_vel,'vy'));
+
+x2=xmin+(0:1:nx)'*spacing; 
+x2=double(x2);
+
+y2=(ymax-ny*spacing)+(0:1:ny)'*spacing; 
+y2=double(y2);
+% }}}
+% {{{ Geometry
+disp('   Interpolating surface and ice base');
+md.geometry.base    = InterpFromGridToMesh(x1,y1,topg,md.mesh.x,md.mesh.y,0);
+md.geometry.surface = InterpFromGridToMesh(x1,y1,usrf,md.mesh.x,md.mesh.y,0);
+clear usrf, topg;
+
+disp('   Constructing thickness');
+md.geometry.thickness=md.geometry.surface-md.geometry.base;
+
+%ensure hydrostatic equilibrium on ice shelf: 
+di=md.materials.rho_ice/md.materials.rho_water;
+
+%Get the node numbers of floating nodes
+pos=find(md.mask.groundedice_levelset<0); 
+
+%apply a flotation criterion on the precedingly defined nodes and
+%redefine base and thickness accordingly
+md.geometry.thickness(pos)=1/(1-di)*md.geometry.surface(pos);
+md.geometry.base(pos)=md.geometry.surface(pos)-md.geometry.thickness(pos);
+md.geometry.hydrostatic_ratio=ones(md.mesh.numberofvertices,1);
+
+%Set min thickness to 1 meter
+pos0=find(md.geometry.thickness<=0);
+md.geometry.thickness(pos0)=1;
+md.geometry.surface=md.geometry.thickness+md.geometry.base;
+% }}} 
+% {{{ Initialization parameters
+disp('   Interpolating temperatures');
+md.initialization.temperature=InterpFromGridToMesh(x1,y1,temp,md.mesh.x,md.mesh.y,0)+273.15+Temp_change;
+clear temp;
+
+disp('   Set observed velocities')
+vx_obs=InterpFromGridToMesh(x2,y2,flipud(velx'),md.mesh.x,md.mesh.y,0);
+vy_obs=InterpFromGridToMesh(x2,y2,flipud(vely'),md.mesh.x,md.mesh.y,0);
+clear velx vely;
+
+vel_obs=sqrt(vx_obs.^2+vy_obs.^2);
+md.initialization.vx=vx_obs;
+md.initialization.vy=vy_obs;
+md.initialization.vz=zeros(md.mesh.numberofvertices,1);
+md.initialization.vel=vel_obs;
+
+disp('   Set Pressure');
+md.initialization.pressure=md.materials.rho_ice*md.constants.g*md.geometry.thickness;
+
+% }}}
+
+disp('   Construct ice rheological properties');
+md.materials.rheology_n=3*ones(md.mesh.numberofelements,1);
+md.materials.rheology_B=paterson(md.initialization.temperature);
+
+% {{{ Forcings
+disp('   Interpolating surface mass balance');
+md.surfaceforcings.mass_balance=InterpFromGridToMesh(x1,y1,smb,md.mesh.x,md.mesh.y,0);
+md.surfaceforcings.mass_balance=md.surfaceforcings.mass_balance*md.materials.rho_water/md.materials.rho_ice;
+clear smb;
+
+disp('   Set geothermal heat flux');
+md.basalforcings.geothermalflux=InterpFromGridToMesh(x1,y1,gflux,md.mesh.x,md.mesh.y,0);
+clear gflux;
+% }}}
+
+% {{{ Friction and inversion set up
+disp('   Construct basal friction parameters');
+md.friction.coefficient=friction_coefficient*ones(md.mesh.numberofvertices,1);
+md.friction.p=ones(md.mesh.numberofelements,1);
+md.friction.q=ones(md.mesh.numberofelements,1);
+
+%no friction applied on floating ice
+pos=find(md.mask.groundedice_levelset<0);
+md.friction.coefficient(pos)=0;
+
+md.inversion=m1qn3inversion();
+md.inversion.vx_obs=vx_obs;
+md.inversion.vy_obs=vy_obs;
+md.inversion.vel_obs=vel_obs;
+% }}}
+
+
+disp('   Set boundary conditions');
+md=SetMarineIceSheetBC(md);
+md.basalforcings.floatingice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.basalforcings.groundedice_melting_rate = zeros(md.mesh.numberofvertices,1);
+md.thermal.spctemperature     = [md.initialization.temperature;1]; %impose observed temperature on surface
+md.masstransport.spcthickness    = NaN*ones(md.mesh.numberofvertices,1);
+
Index: issm/trunk/examples/Pig/PigRegion.m
===================================================================
--- issm/trunk/examples/Pig/PigRegion.m	(revision 18301)
+++ issm/trunk/examples/Pig/PigRegion.m	(revision 18301)
@@ -0,0 +1,54 @@
+% {{{ Getting the velocity in PIG vicinity for the ExpDraw
+
+% Load Velocities
+% http://nsidc.org/data/nsidc-0484.html
+nsidc_vel='../Data/Antarctica_ice_velocity.nc'; 	
+
+% Get necessary data to build up the velocity grid
+xmin = ncreadatt(nsidc_vel,'/','xmin');
+xmin = strtrim(xmin);  % this is a string, and we need to recover the double value
+xmin = xmin(1:end-2);  % get rid of the unit
+xmin = str2num(xmin);  % convert to double
+
+ymax = ncreadatt(nsidc_vel,'/','ymax'); 
+ymax = strtrim(ymax);  
+ymax = ymax(1:end-2);  
+ymax = str2num(ymax); 
+	
+nx = ncreadatt(nsidc_vel,'/','nx');
+ny = ncreadatt(nsidc_vel,'/','ny');
+
+spacing = ncreadatt(nsidc_vel,'/','spacing'); 
+spacing = strtrim(spacing);
+spacing = spacing(1:end-2);  
+spacing = str2num(spacing); 
+
+
+x=xmin+(0:1:nx-1)'*spacing; 
+x=double(x);
+y=(ymax)-(0:1:ny-1)'*spacing; 
+y=double(y);
+
+posx=find(x<=-12.0e5);
+id1x=find(x>=-18.0e5,1);
+id2x=posx(end);
+
+posy=find(y>=-4.0e5);
+id1y=find(y<=1.0e5,1);
+id2y=posy(end);
+
+%Get velocity subset
+vx = double(ncread(nsidc_vel,'vx'));
+vx_obs = vx(id1x:id2x,id1y:id2y);
+vx_obs = flipud(vx_obs');
+
+vy = double(ncread(nsidc_vel,'vy'));
+vy_obs = vy (id1x:id2x,id1y:id2y);
+vy_obs = flipud(vy_obs');
+
+xred=x(id1x:id2x);
+yred=y(id1y:id2y);
+vel_obs=sqrt(vx_obs.^2.+vy_obs.^2.);
+imagesc(xred,yred,vel_obs)
+
+%}}}
